Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.core.util
Class PreparedSelectorGenerator

    java.lang.Object
      oracle.ifs.core.util.PreparedSelectorGenerator

    public class PreparedSelectorGenerator

extends java.lang.Object

Validates and generates search and sort clauses of a query specification executed by a PreparedSelector.

Nested Class Summary
`class` | `PreparedSelectorGenerator.SelectorFunction` A SelectorFunction holds information about an embedded function in the search or sort conditions.

Field Summary
`protected static java.lang.String` | `CONTEXT_DOCUMENT_VIEW_NAME` The name of the view used in full-text searches on DOCUMENT.

Constructor Summary
`PreparedSelectorGenerator()` Constructs a PreparedSelectorGenerator.

Method Summary
`java.lang.String` | `ATTR(java.lang.String input)` Translates an attribute specification into a column specification.
`java.lang.String` | `CATEGORY_JOIN(java.lang.String input)` Generates a join clause between two targets, one being a category target.
`protected long[]` | `computeDateValueRange(java.lang.Long dateValue, java.lang.String granularity)` Compute a low/high value range for the specified numeric date value, using the specified granularity.
`protected java.lang.String` | `concatTokenList(java.util.List list)` Concatenate a list of tokens, comprised of literal strings and functions.
`java.lang.String` | `CONTAINS(java.lang.String input)` Adds a clause that restricts results according to a full text search qualification.
`java.lang.String` | `CONTENT_SCORE(java.lang.String input)` Adds the SQL referencing the content score as a column in a search or sort condition.
`java.lang.String` | `CONTENT_SIZE(java.lang.String input)` Adds the SQL referencing the content size as a column in a search or sort condition.
`static AttributeValue` | `createSearchTarget(java.lang.String targetToken)` Create a search target specification.
`java.lang.String` | `DATE_COMPARE(java.lang.String input)` Generates a date comparison clause from a specified attribute, a logical operator, a date value, and a granularity value.
`java.lang.String` | `DATE_VALUE_NOW(java.lang.String input)` Generates a numeric value representing the current time.
`void` | `define(LibrarySession session, AttributeValue primaryTarget, AttributeValue[] auxTargets, java.lang.String searchCondition, java.lang.String sortCondition, AttributeValue[] bindValues)` Defines a PreparedSelectorGenerator.
`java.lang.String` | `EXACT_TYPE(java.lang.String input)` Adds a qualification that requires an exact type match.
`java.lang.String` | `EXISTS(java.lang.String input)` Adds a qualification for a simple "exists" specification.
`protected Attribute` | `findAttributeByAuxName(LibrarySession session, ClassObject co, java.lang.String attrName)` Lookup an Attribute using an auxilliary name.
`protected ClassObject` | `findClassObjectByAuxName(LibrarySession session, java.lang.String className)` Find a ClassObject using an auxilliary name.
`protected int` | `findFunctionEnd(java.lang.String input, int lcurlyPos)` Find the closing right curly that marks the end of the function, given a string and the position of the left curly.
`protected int` | `findFunctionStart(java.lang.String input, int lcurlyPos)` Find the start of the function, given a string and the position of the left curly.
`protected java.lang.String` | `getAliasFromTarget(AttributeValue target)` Returns the alias name from the specified search target.
`AttributeValue[]` | `getAuxiliarySearchTargets()` Returns the auxiliary search targets.
`AttributeValue[]` | `getBindValues()` Returns the bind values.
`protected java.lang.String` | `getClassFromTarget(AttributeValue target)` Returns the class name from the specified search target.
`protected java.lang.String` | `getClassNameFromAlias(java.lang.String alias)` Returns the Class name associated with the specified registered alias.
`protected ClassObject` | `getClassObjectFromAlias(java.lang.String alias)` Returns the ClassObject associated with the specified registered alias.
`protected ClassObject` | `getClassObjectFromTarget(AttributeValue target)` Returns the class object from the specified search target.
`protected java.lang.reflect.Method` | `getFunctionMethod(java.lang.String key)` Gets the method to use for resolving the specified function.
`AttributeValue` | `getPrimarySearchTarget()` Returns the primary search target.
`java.lang.String` | `getSearchCondition()` Gets the raw search condition specified during construction.
`protected java.lang.String` | `getSearchTargetSqlFromAlias(java.lang.String alias)` Generates the SQL for a search target, identified by registered alias.
`LibrarySession` | `getSession()` Gets the session context used by this instance.
`java.lang.String` | `getSortClause()` Returns the Sort Clause.
`java.lang.String` | `getSortCondition()` Gets the raw sort condition specified during construction.
`java.lang.String` | `getWhereClause()` Returns the "where Clause" used as the search condition in a PreparedSelector.
`java.lang.String` | `IN_FOLDER(java.lang.String input)` Generates a the clause that restricts a specified alias to a particular folder.
`protected boolean` | `isNumber(java.lang.String value)` Check if the input string represents a number.
`java.lang.String` | `LATEST_VERSION(java.lang.String input)` Adds a qualification that restricts results for only the latest version or unversioned items.
`java.lang.String` | `LITERAL(java.lang.String input)` A no-op function, returning the literal resolution of the input string.
`protected java.lang.String` | `lookupClassNameByNickname(java.lang.String nickname)` Looks up a ClassObject name by the specified class "nickname".
`protected AttributeValue` | `lookupSearchTarget(AttributeValue target)` Returns the search target from the table map matching the provided target's associated alias.
`protected AttributeValue` | `lookupSearchTarget(java.lang.String alias)` Lookup a search target by registered alias.
`protected AttributeValue[]` | `lookupSearchTargets(AttributeValue[] targets)` Returns the search targets from the table map matching the provided targets associated aliases.
`protected void` | `overrideTargetViewName(java.lang.String alias, java.lang.String viewName)` Overrides the view name to be used with the search target identified by the alias specified.
`protected java.util.List` | `parseInput(java.lang.String input)` Create a token list from an input string.
`protected java.lang.Long` | `parseNumber(java.lang.String value)` Return numeric equivalent of the specified string, or return null if not a number.
`protected AttributeValue` | `registerSearchTarget(java.lang.String input)` Parses and registers a new search target.
`java.lang.String` | `SEARCH_TARGET(java.lang.String input)` Registers a new search target, and generates SQL for it to appear in a "from clause".
`java.lang.String` | `SECURITY_CLAUSE(java.lang.String input)` Adds a security qualification for an alias.
`protected void` | `throwInvalidFunction(java.lang.String funcName, java.lang.String input)` Throw an exception indicating an invalid search function.
`java.lang.String` | `UNDER_FOLDER(java.lang.String input)` Generates a the clause that restricts a specified alias to a particular folder or one of its subfolders.
`void` | `validate()` Validate the search specifications.
`protected AttributeValue` | `validateBindValue(AttributeValue bindValue)` Validate a bind value.
`protected void` | `validateSearchCondition(java.lang.String search)` Validate the search condition.
`protected AttributeValue` | `validateSearchTarget(AttributeValue target)` Validate a search target, and registers it if it is valid.
`protected void` | `validateSortCondition(java.lang.String sort)` Validate the sort condition.
`protected void` | `verifyDocumentTarget(java.lang.String alias)` Verify that the class name in the search target identified by the alias specified is DOCUMENT.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CONTEXT_DOCUMENT_VIEW_NAME

    protected static final java.lang.String CONTEXT_DOCUMENT_VIEW_NAME

  Description copied from class: `PreparedSelectorGenerator`
  The name of the view used in full-text searches on DOCUMENT.

  See Also:
    Constant Field Values

Constructor Detail

### PreparedSelectorGenerator

    public PreparedSelectorGenerator()

  Constructs a PreparedSelectorGenerator.

Method Detail

### define

    public void define(LibrarySession session,
                       AttributeValue primaryTarget,
                       AttributeValue[] auxTargets,
                       java.lang.String searchCondition,
                       java.lang.String sortCondition,
                       AttributeValue[] bindValues)
                throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Defines a PreparedSelectorGenerator.

  Parameters:
    `session` - the current session
    `primaryTarget` - the primary search target
    `auxTargets` - the auxiliary search targets
    `searchCondition` - the search selection
    `sortCondition` - the sort specification
    `bindValues` - the bind values
  Throws:
    `IfsException` - if the operation fails.

### getSession

    public LibrarySession getSession()

  Description copied from class: `PreparedSelectorGenerator`
  Gets the session context used by this instance.

  Returns:
    the session context

### getSearchCondition

    public java.lang.String getSearchCondition()

  Description copied from class: `PreparedSelectorGenerator`
  Gets the raw search condition specified during construction.

  Returns:
    the search condition

### getSortCondition

    public java.lang.String getSortCondition()

  Description copied from class: `PreparedSelectorGenerator`
  Gets the raw sort condition specified during construction.

  Returns:
    the sort condition

### getWhereClause

    public java.lang.String getWhereClause()
                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the "where Clause" used as the search condition in a PreparedSelector.

  Returns:
    the generated where clause
  Throws:
    `IfsException` - if the operation fails.

### getSortClause

    public java.lang.String getSortClause()
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the Sort Clause.

  Returns:
    the generated sort clause
  Throws:
    `IfsException` - if the operation fails.

### getPrimarySearchTarget

    public AttributeValue getPrimarySearchTarget()
                                          throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the primary search target.

  Returns:
    the primary search target.
  Throws:
    `IfsException` - if the operation fails.

### getAuxiliarySearchTargets

    public AttributeValue[] getAuxiliarySearchTargets()
                                               throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the auxiliary search targets.

  Returns:
    the auxiliary search targets.
  Throws:
    `IfsException` - if the operation fails.

### getBindValues

    public AttributeValue[] getBindValues()
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the bind values.

  Returns:
    the bind values.
  Throws:
    `IfsException` - if the operation fails.

### validate

    public void validate()
                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Validate the search specifications.

  Throws:
    `IfsException` - if the operation fails

### validateSearchCondition

    protected void validateSearchCondition(java.lang.String search)
                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Validate the search condition.

  Parameters:
    `search` - the search condition
  Throws:
    `IfsException` - if the operation fails

### validateSortCondition

    protected void validateSortCondition(java.lang.String sort)
                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Validate the sort condition.

  Parameters:
    `sort` - the sort condition
  Throws:
    `IfsException` - if the operation fails

### validateBindValue

    protected AttributeValue validateBindValue(AttributeValue bindValue)
                                        throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Validate a bind value.

  Parameters:
    `bindValue` - the bind value.
  Returns:
    the validated and potentially modified bind value.
  Throws:
    `IfsException` - if the operation fails.

### validateSearchTarget

    protected AttributeValue validateSearchTarget(AttributeValue target)
                                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Validate a search target, and registers it if it is valid.

  Parameters:
    `target` - the search target.
  Returns:
    the validated, registered, and potentially modified search target.
  Throws:
    `IfsException` - if the operation fails.

### registerSearchTarget

    protected AttributeValue registerSearchTarget(java.lang.String input)
                                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Parses and registers a new search target.

  The input expression is: `class alias` where: class is a class name, nickname, or category display name, and alias is a valid table alias.

  Parameters:
    `input` - the input expression.
  Returns:
    the registered search target
  Throws:
    `IfsException` - if operation fails.

### findClassObjectByAuxName

    protected ClassObject findClassObjectByAuxName(LibrarySession session,
                                                   java.lang.String className)
                                            throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Find a ClassObject using an auxilliary name.

  Subclasses can override this to provide alternate name checks, such as ECM code attempting a DisplayName lookup.

  Parameters:
    `session` - the session context
    `className` - the name given for the class
  Returns:
    the matching ClassObject, or null if no match
  Throws:
    `IfsException` - if operation fails.

### findAttributeByAuxName

    protected Attribute findAttributeByAuxName(LibrarySession session,
                                               ClassObject co,
                                               java.lang.String attrName)
                                        throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Lookup an Attribute using an auxilliary name.

  Used as a last resort when an attribute specification does not map to an attribute for the associated alias.

  Parameters:
    `session` - the session context.
    `co` - the ClassObject to look in.
    `attrName` - the name given for the attribute.
  Returns:
    the Attribute, or null if no match
  Throws:
    `IfsException` - if operation fails.

### lookupClassNameByNickname

    protected java.lang.String lookupClassNameByNickname(java.lang.String nickname)
                                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Looks up a ClassObject name by the specified class "nickname".

  This can be overriden by subclasses, to provide nickname look for application-specific classes (e.g. for ECM). The caller ensures that the nickname is forced to uppercase.

  Parameters:
    `nickname` - the class nickname (must be all uppercase)
  Returns:
    the actual ClassObject name, or null if no match
  Throws:
    `IfsException` - if operation fails.

### lookupSearchTarget

    protected AttributeValue lookupSearchTarget(java.lang.String alias)

  Description copied from class: `PreparedSelectorGenerator`
  Lookup a search target by registered alias.

  Parameters:
    `alias` - the registered alias.
  Returns:
    the search target.

### getClassFromTarget

    protected java.lang.String getClassFromTarget(AttributeValue target)
                                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the class name from the specified search target.

  Parameters:
    `target` - the search target specification.
  Returns:
    the class name.
  Throws:
    `IfsException` - if operation fails.

### getAliasFromTarget

    protected java.lang.String getAliasFromTarget(AttributeValue target)
                                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the alias name from the specified search target.

  Parameters:
    `target` - the search target specification.
  Returns:
    the alias name.
  Throws:
    `IfsException` - if operation fails.

### getClassNameFromAlias

    protected java.lang.String getClassNameFromAlias(java.lang.String alias)
                                              throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the Class name associated with the specified registered alias.

  Throws if the alias is not known.

  Parameters:
    `alias` - the search target alias
  Returns:
    the associated Class name.
  Throws:
    `IfsException` - if operation fails.

### getClassObjectFromAlias

    protected ClassObject getClassObjectFromAlias(java.lang.String alias)
                                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the ClassObject associated with the specified registered alias.

  Parameters:
    `alias` - the search target alias
  Returns:
    the associated ClassObject.
  Throws:
    `IfsException` - if operation fails.

### getClassObjectFromTarget

    protected ClassObject getClassObjectFromTarget(AttributeValue target)
                                            throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the class object from the specified search target.

  Parameters:
    `target` - the search target specification.
  Returns:
    the ClassObject.
  Throws:
    `IfsException` - if operation fails.

### lookupSearchTarget

    protected AttributeValue lookupSearchTarget(AttributeValue target)
                                         throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the search target from the table map matching the provided target's associated alias.

  Parameters:
    `target` - the provided search target.
  Returns:
    the corresponding search target in the table map.
  Throws:
    `IfsException` - if operation fails.

### lookupSearchTargets

    protected AttributeValue[] lookupSearchTargets(AttributeValue[] targets)
                                            throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Returns the search targets from the table map matching the provided targets associated aliases.

  Parameters:
    `targets` - the provided search targets.
  Returns:
    the corresponding search targets in the table map.
  Throws:
    `IfsException` - if operation fails.

### verifyDocumentTarget

    protected void verifyDocumentTarget(java.lang.String alias)
                                 throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Verify that the class name in the search target identified by the alias specified is DOCUMENT.

  If the class name is DOCUMENT, this method also overrides the view name in the search target, so that odmz_context_document is used in the search instead of odmv_document.

  Parameters:
    `alias` - the search target alias.
  Throws:
    `IfsException` - if operation fails.

### overrideTargetViewName

    protected void overrideTargetViewName(java.lang.String alias,
                                          java.lang.String viewName)
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Overrides the view name to be used with the search target identified by the alias specified.

  Parameters:
    `alias` - the search target alias.
    `viewName` - the view name.
  Throws:
    `IfsException` - if operation fails.

### getSearchTargetSqlFromAlias

    protected java.lang.String getSearchTargetSqlFromAlias(java.lang.String alias)
                                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates the SQL for a search target, identified by registered alias.

  The SQL is: "viewname alias".

  Parameters:
    `alias` - the registered alias.
  Returns:
    the SQL expression.
  Throws:
    `IfsException` - if operation fails.

### throwInvalidFunction

    protected void throwInvalidFunction(java.lang.String funcName,
                                        java.lang.String input)
                                 throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Throw an exception indicating an invalid search function.

  Parameters:
    `funcName` - the function name.
    `input` - the input string.
  Throws:
    `IfsException` - IFS-35235

### isNumber

    protected boolean isNumber(java.lang.String value)

  Description copied from class: `PreparedSelectorGenerator`
  Check if the input string represents a number.

  Parameters:
    `value` - the input string.
  Returns:
    true if string is a number; false otherwise.

### parseNumber

    protected java.lang.Long parseNumber(java.lang.String value)

  Description copied from class: `PreparedSelectorGenerator`
  Return numeric equivalent of the specified string, or return null if not a number.

  Parameters:
    `value` - the input string.
  Returns:
    the number, or null if string is not numeric

### computeDateValueRange

    protected long[] computeDateValueRange(java.lang.Long dateValue,
                                           java.lang.String granularity)
                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Compute a low/high value range for the specified numeric date value, using the specified granularity.

  For example, if the date value specified was the numeric represenation of '14-aug-2009 17:50:20' and a comparison level of MONTH is specified, then the range returned is '01-aug-2009 00:00:00.0' and '31-aug-2009 23:59:59.999'.

  Parameters:
    `dateValue` - a non-null numeric date value, obtained via `getTime` on a java.util.Date
    `granularity` - the granularity, one of "YEAR", "MONTH", "DAY", "HOUR", "MINUTE", or "SECOND"
  Returns:
    the low and high range values
  Throws:
    `IfsException` - if the operation fails

### createSearchTarget

    public static AttributeValue createSearchTarget(java.lang.String targetToken)
                                             throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Create a search target specification.

  Format of the string is [ ].

  Parameters:
    `targetToken` - the string token representing the search target
  Returns:
    the search target specification
  Throws:
    `IfsException` - if the operation fails

### parseInput

    protected java.util.List parseInput(java.lang.String input)
                                 throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Create a token list from an input string.

  The list will be compromised on both literal Strings and SelectorFunctions.

  Parameters:
    `input` - the input string.
  Returns:
    the list of tokens.
  Throws:
    `IfsException` - if operation fails.

### findFunctionStart

    protected int findFunctionStart(java.lang.String input,
                                    int lcurlyPos)
                             throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Find the start of the function, given a string and the position of the left curly.

  Parameters:
    `input` - the input string
    `lcurlyPos` - the position of the left curly
  Returns:
    the position where the function name begins.
  Throws:
    `IfsException` - if operation fails.

### findFunctionEnd

    protected int findFunctionEnd(java.lang.String input,
                                  int lcurlyPos)
                           throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Find the closing right curly that marks the end of the function, given a string and the position of the left curly.

  Parameters:
    `input` - the input string
    `lcurlyPos` - the position of the left curly
  Returns:
    the position where the function ends.
  Throws:
    `IfsException` - if operation fails.

### concatTokenList

    protected java.lang.String concatTokenList(java.util.List list)
                                        throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Concatenate a list of tokens, comprised of literal strings and functions.

  Parameters:
    `list` - the token list.
  Returns:
    the resultant string.
  Throws:
    `IfsException` - if operation fails.

### LITERAL

    public java.lang.String LITERAL(java.lang.String input)
                             throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  A no-op function, returning the literal resolution of the input string.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### EXACT_TYPE

    public java.lang.String EXACT_TYPE(java.lang.String input)
                                throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds a qualification that requires an exact type match.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### CONTENT_SIZE

    public java.lang.String CONTENT_SIZE(java.lang.String input)
                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds the SQL referencing the content size as a column in a search or sort condition.

  Derived from ContentObject.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### CONTENT_SCORE

    public java.lang.String CONTENT_SCORE(java.lang.String input)
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds the SQL referencing the content score as a column in a search or sort condition.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### CONTAINS

    public java.lang.String CONTAINS(java.lang.String input)
                              throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds a clause that restricts results according to a full text search qualification.

  The SQL generated is one of: (CTXSYS.CONTAINS(alias.contentindex, ?) > 0) or (CTXSYS.CONTAINS(alias.contentindex, ?, n) > 0)

  The input must be sepcified as: `alias, ?`. NOTE: the alias must be associated with a DOCUMENT_CONTEXT search target.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### LATEST_VERSION

    public java.lang.String LATEST_VERSION(java.lang.String input)
                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds a qualification that restricts results for only the latest version or unversioned items.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### SEARCH_TARGET

    public java.lang.String SEARCH_TARGET(java.lang.String input)
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Registers a new search target, and generates SQL for it to appear in a "from clause".

  The input expression is: `class alias` where: class is a class name, nickname, or application-specific display name, and alias is a valid table alias.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### ATTR

    public java.lang.String ATTR(java.lang.String input)
                          throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Translates an attribute specification into a column specification.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### CATEGORY_JOIN

    public java.lang.String CATEGORY_JOIN(java.lang.String input)
                                   throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates a join clause between two targets, one being a category target.

  The input expression is of the form: `assocAlias, catAlias`.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### IN_FOLDER

    public java.lang.String IN_FOLDER(java.lang.String input)
                               throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates a the clause that restricts a specified alias to a particular folder.

  The input expression is of the form: `alias, ?`. A bind value indicator must be used for the folder.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### UNDER_FOLDER

    public java.lang.String UNDER_FOLDER(java.lang.String input)
                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates a the clause that restricts a specified alias to a particular folder or one of its subfolders.

  The input expression is of the form: `alias, ?`. A bind value indicator must be used for the folder.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### EXISTS

    public java.lang.String EXISTS(java.lang.String input)
                            throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds a qualification for a simple "exists" specification.

  The input expression must be: `class alias, ... class alias, condition`. where:

  - "class alias" follows the same syntax as in search target specifications,
  - "condition" can be any valid search condition, which is included in a subselect. It is recommended that the search condition be enclosed in a LITERAL function, as: LITERAL{condition}

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### SECURITY_CLAUSE

    public java.lang.String SECURITY_CLAUSE(java.lang.String input)
                                     throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Adds a security qualification for an alias.

  Input must be "alias, ?", where the bind value indication is for the current user ID. If the specified registered alias is associated with a PublicObject class, a discover-security clause is returned. Otherwise, a clause of "29 != ?" is returned (which will always be true).

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### DATE_COMPARE

    public java.lang.String DATE_COMPARE(java.lang.String input)
                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates a date comparison clause from a specified attribute, a logical operator, a date value, and a granularity value.

  The operator must be one of: =, !=, >, >=, <, or <=. The granularity must be one of: YEAR, MONTH, DAY, HOUR, MINUTE, or SECOND. Case is not significant for these values.

  The input expression is of the form: `, , ,` . For example, for comparing an attribute named "archivedate" equal to the current time, with day granularity: `DATE_COMPARE{ATTR{cat.archivedate}, =, DATE_VALUE_NOW{}, Day`.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### DATE_VALUE_NOW

    public java.lang.String DATE_VALUE_NOW(java.lang.String input)
                                    throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Generates a numeric value representing the current time.

  Parameters:
    `input` - the input expression.
  Returns:
    the resolved expression.
  Throws:
    `IfsException` - if operation fails.

### getFunctionMethod

    protected java.lang.reflect.Method getFunctionMethod(java.lang.String key)
                                                  throws IfsException

  Description copied from class: `PreparedSelectorGenerator`
  Gets the method to use for resolving the specified function.

  Parameters:
    `key` - the method name
  Returns:
    the method
  Throws:
    `IfsException` - if the operation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD